searchNodes=[{"doc":"ExCmd is an Elixir library to run and communicate with external programs with back-pressure.","ref":"ExCmd.html","title":"ExCmd","type":"module"},{"doc":"Returns a ExCmd.Stream for the given cmd with arguments args. The stream implements both Enumerable and Collectable protocols, which means it can be used both for reading from stdout and write to stdin of an OS process simultaneously (see examples). Options exit_timeout - Duration to wait for external program to terminate after completion before raising an error. Defaults to :infinity All other options are passed to ExCmd.Process.start_link/3 Since reading and writing are blocking actions, these should be done in separate processes (unless you know each input producess an output) Examples def audio_stream!(stream) do # read from stdin and write to stdout proc_stream = ExCmd.stream!(&quot;ffmpeg&quot;, ~w(-i - -f mp3 -)) Task.async(fn -&gt; Stream.into(stream, proc_stream) |&gt; Stream.run() end) proc_stream end File.stream!(&quot;music_video.mkv&quot;, [], 65535) |&gt; audio_stream!() |&gt; Stream.into(File.stream!(&quot;music.mp3&quot;)) |&gt; Stream.run()","ref":"ExCmd.html#stream!/3","title":"ExCmd.stream!/3","type":"function"},{"doc":"Helper to interact with ExCmd.ProcessServer Overview Each ExCmd.ProcessServer process maps to an instance of port (and an OS process). Internally ExCmd.ProcessServer creates and manages separate processes for each of the IO streams (Stdin, Stdout, Stderr) and a port that maps to an OS process of odu. Blocking functions such as read and write only blocks the calling process, not the ExCmd.Process itself. A blocking read does not block a parallel write. Blocking calls are the primitives for building back-pressure. For most of the use-cases using ExCmd.stream! abstraction should be enough. Use this only if you need more control over the life-cycle of IO streams and OS process.","ref":"ExCmd.Process.html","title":"ExCmd.Process","type":"module"},{"doc":"Waits for the program to terminate. If the program terminates before timeout, it returns {:ok, exit_status} else returns :timeout","ref":"ExCmd.Process.html#await_exit/2","title":"ExCmd.Process.await_exit/2","type":"function"},{"doc":"Closes input stream. Which signal EOF to the program","ref":"ExCmd.Process.html#close_input/1","title":"ExCmd.Process.close_input/1","type":"function"},{"doc":"Opens the error stream of the program for reading. Blocks till writer opens","ref":"ExCmd.Process.html#open_error/1","title":"ExCmd.Process.open_error/1","type":"function"},{"doc":"Opens the input stream of the program for writing. Blocks till reader opens","ref":"ExCmd.Process.html#open_input/1","title":"ExCmd.Process.open_input/1","type":"function"},{"doc":"Opens the output stream of the program for reading. Blocks till writer opens","ref":"ExCmd.Process.html#open_output/1","title":"ExCmd.Process.open_output/1","type":"function"},{"doc":"Returns port_info","ref":"ExCmd.Process.html#port_info/1","title":"ExCmd.Process.port_info/1","type":"function"},{"doc":"Return bytes written by the program to output stream. This blocks until the programs write and flush the output","ref":"ExCmd.Process.html#read/2","title":"ExCmd.Process.read/2","type":"function"},{"doc":"Return bytes written by the program to error stream. This blocks until the programs write and flush the output","ref":"ExCmd.Process.html#read_error/2","title":"ExCmd.Process.read_error/2","type":"function"},{"doc":"Opens the port and runs the program","ref":"ExCmd.Process.html#run/1","title":"ExCmd.Process.run/1","type":"function"},{"doc":"Starts ExCmd.ProcessServer Starts a process for running cmd with arguments args with options opts. Note that this does not run the program immediately. User has to explicitly run by calling run/1, open_input/1, open_output/1 depending on the program. Options use_stderr - Whether to allow reading from stderr. Note that setting true but not reading from stderr might block external program due to back-pressure. Defaults to false log - When set to true odu outputs are logged. Defaults to false","ref":"ExCmd.Process.html#start_link/3","title":"ExCmd.Process.start_link/3","type":"function"},{"doc":"Returns status of the process. It will be either of :started, {:done, exit_status}","ref":"ExCmd.Process.html#status/1","title":"ExCmd.Process.status/1","type":"function"},{"doc":"Kills the program","ref":"ExCmd.Process.html#stop/1","title":"ExCmd.Process.stop/1","type":"function"},{"doc":"Writes iodata data to programs input streams This blocks when the fifo is full","ref":"ExCmd.Process.html#write/3","title":"ExCmd.Process.write/3","type":"function"},{"doc":"","ref":"ExCmd.ProcessServer.html","title":"ExCmd.ProcessServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"ExCmd.ProcessServer.html#child_spec/1","title":"ExCmd.ProcessServer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2.","ref":"ExCmd.ProcessServer.html#handle_continue/2","title":"ExCmd.ProcessServer.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExCmd.ProcessServer.html#init/1","title":"ExCmd.ProcessServer.init/1","type":"function"},{"doc":"","ref":"ExCmd.ProcessServer.html#start_link/3","title":"ExCmd.ProcessServer.start_link/3","type":"function"},{"doc":"Defines a ExCmd.Stream struct returned by ExCmd.stream!/3.","ref":"ExCmd.Stream.html","title":"ExCmd.Stream","type":"module"},{"doc":"","ref":"ExCmd.Stream.html#t:t/0","title":"ExCmd.Stream.t/0","type":"type"},{"doc":"ExCmd ExCmd is an Elixir library to run and communicate with external programs with back-pressure. ExCmd is built around the idea of streaming data through an external program. Think streaming a video through ffmpeg to server a web request. For example, getting audio out of a stream is as simple as def audio_stream!(stream) do # read from stdin and write to stdout proc_stream = ExCmd.stream!(&quot;ffmpeg&quot;, ~w(-i - -f mp3 -)) Task.async(fn -&gt; Stream.into(stream, proc_stream) |&gt; Stream.run() end) proc_stream end File.stream!(&quot;music_video.mkv&quot;, [], 65535) |&gt; audio_stream!() |&gt; Stream.into(File.stream!(&quot;music.mp3&quot;)) |&gt; Stream.run() ExCmd.stream! is a convenience wrapper around ExCmd.ProcServer. If you want more control over stdin, stdout and os process use ExCmd.ProcServer directly. Note: ExCmd is still work-in-progress. Expect breaking changes Why not use built-in ports? Unlike beam ports, ExCmd puts back pressure on the external program Proper program termination. No more zombie process Ability to close stdin and wait for output (with ports one can not selectively close stdin) If all you want is to run a command with no communication, then just sticking with System.cmd is a better option.","ref":"readme.html","title":"ExCmd","type":"extras"},{"doc":"Each ExCmd.ProcessServer process maps to an OS process. Internally ExCmd.ProcessServer creates and manages separate processes for each of the IO streams (Stdin, Stdout, Stderr) and a port that maps to an OS process (an odu process). Keeping input, output and the OS process as a separate beam process helps us to handle them independently (closing stdin, blocking the OS process by not opening stdout pipe). Conceptually this directly maps to the OS primitives. Blocking functions such as read and write only blocks the calling process, not the ExCmd.Process itself. A blocking read does not block a parallel write. These blocking calls are the primitives for building back-pressure. For most of the use-cases using ExCmd.stream! abstraction should be enough. Use ExCmd.ProcessServer only if you need more control over the life-cycle of IO streams and OS process. Check documentation for information Why not use NIF? These are essentially same as &quot;why use port over NIF&quot; Safety: Failures in external command or ExCmd doesn&#39;t bring whole VM down Scheduling: ExCmd plays well with the beam scheduler, you don&#39;t have to worry about blocking scheduler Ease: It is easier to work with an Elixir library than to understanding NIF Ergonomics: ExCmd can be thought as just linking your beam processes and external program with good old pipes ExCmd uses odu as a middleware to fill the gaps left ports.","ref":"readme.html#overview","title":"ExCmd - Overview","type":"extras"},{"doc":"Install odu and make sure its in your path Install ExCmd def deps do [ {:ex_cmd, &quot;~&gt; x.x.x&quot;} ] end","ref":"readme.html#installation","title":"ExCmd - Installation","type":"extras"}]